% This file makes comparison between forecasts of MRSTAR and GSTAR in Tables 6-7 of Main Text and Table 12 of Supplement of Zanetti Chini (2018); 
%

clear; 
clc;
% data - example
randn('state', 535621);
%data = random('Normal',0,1,100,1);
importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSIIP.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/mUSUN.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/lynx.xls');
%importfile('/Users/emiliozanettichini/Desktop/WP/GSTR/Data/ssn_yearly.xls')
%
% Select data
data = 100*(log(mIIP) - lag(log(mIIP),12))/12; data=data(13:end);         % US IIP in monthly growth rate
%data = 100*(log(mUN) - lag(log(mUN),12))/12; data=data(13:end);            % US UNEMPLOYEMNT RATE in levels                                                                      
%data = log10(LYNX);                                                       % Canadian Lynx
%data = sqrt(SSN(1:end-3));                                                % Yearly SSN (use square root transformation)
%data = log(MSmoothSSN(1213:end));                                          % Monthly Smoothed SSN (log tansformation)
%data = y - lag(y,1) ; (eventually in change rate)
c = mean(data);
%
T=size(data,1);
O = ones(T,1);
x0 = [O lag(data,1) ];
%x1 = [O lag(data,1) lag(data,2) lag(data,3)   ];
x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) lag(data,5) lag(data,6)];
%x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) lag(data,5) lag(data,6) lag(data,7) lag(data,8) lag(data,9)  ];
%x1 = [O lag(data,1) lag(data,2) lag(data,3) lag(data,4) lag(data,5) lag(data,6) lag(data,7) lag(data,8) lag(data,9) lag(data,10) lag(data,11) lag(data,12) ];
h=size(x1,2)-1; 

open IPyhat_mrstar.mat; yhat1=ans.yhat;
open IPyhat_gstar.mat; yhat2=ans.yhat_gstar;
open IPehat_mrstar.mat; ehat1=ans.ehat;
open IPehat_gstar.mat; ehat2=ans.ehat_gstar;

%open UNyhat_mrstar.mat; yhat=ans.yhat;
%open UNyhat_gstar.mat; yhat=ans.yhat_gstar;
%open UNehat_mrstar.mat; ehat=ans.ehat;
%open UNehat_gstar.mat; ehat=ans.ehat_gstar;


%open SSNyhat_mrstar.mat; yhat1=ans.yhat;
%open SSNyhat_gstar.mat; yhat2=ans.yhat_gstar;
%open SSNehat_mrstar.mat; ehat1=ans.ehat;
%open SSNehat_gstar.mat; ehat2=ans.ehat_gstar;

%open LYNXyhat_mrstar.mat; yhat=ans.yhat;
%open LYNXyhat_gstar.mat; yhat=ans.yhat_gstar;
%open LYNXehat_mrstar.mat; ehat=ans.ehat;
%open LYNXehat_gstar.mat; ehat=ans.ehat_gstar;


%select bandwidth for the Rolling Window
alpha = 0.05;
h=1;
bw = 150;
oos_reg0=[]; oos_reg1=[]; oos_reg2=[]; yoos=[]; predreg=[];
% without out of sample
for i=1:T-(bw+h)+1
    [B0 Bint0 R0] = regress(data(i:i+bw-1,:),x0(i:i+bw-1,:));
    %[B1 Bint1 R1] = regress(data(i:i+bw-1,:),x1(i:i+bw-1,:));
    e1= ehat1(i:i+bw-1,:);
    p1= ehat2(i:i+bw-1,:);
    
    oos_reg0(i,:)=  [ x0(bw+i,:)];
    oos_reg1(i,:)=  [ yhat1(bw+i,:)];
    oos_reg2(i,:)=  [ yhat2(bw+i,:)];
    yoos(i,:) = data(bw+i,:);
  
end
time=calendar(1947,1,783,'m'); tds=calendar_plot(1959,6,633,'m');
result = testsoos2(e1,p1,1,1,time,tds);