function [ypred] = forecast(y, beta, T, R, l, p)
Y=zeros(T,p-1);
A0=zeros(1,size(Y,2)); A0(1,1)=beta(1,1);
EYE = [eye(p-2,p-2) zeros(p-2,1)]; 
A1=zeros(p-1,p-1); 
A1=[beta(2:end)'; EYE]; 

for i=1:p
Y(:,i) = lag(y,i-1);
end

Pol = zeros(size(A1,1), l-1);
O = ones(p-1,p-1);
for i=1:p-1
    for j=1:p-1
        Pol(i,j) = O(i,j) + A1(i,j).^(l-1)
    end
end