function [y_nladd, u_nladd] = sim_nlARadd(theta0add, thetadd, Gadd, T, sigerr)

%Preallocate
y_nladd = zeros(T,1);


%Definitions
eps = sqrt(sigerr)*randn(T,1);

%Simulate a Nonlinear (GSTAR) process
for i= 3 : T-1
    y_nladd(i) = theta0add + [Gadd(i-1), Gadd(i-2)]*thetadd + eps(i);
    u_nladd = y_nladd  - theta0add - [Gadd(i-1), Gadd(i-2)]*thetadd ;
end
y_nladd=y_nladd(3:end,:); 



end